<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Companies</title>
    <style>
        * {
            font-family: Calibri;
        }
    </style>
</head>

<body>
    <h1>Lahedad ettevõtted</h1>
    <div id="companies"></div>
    <div>
        <h2>Lisa etteõte</h2>
        Nimi: <br>
        <input type="text" id="name"><br><br>
        Asutatud: <br>
        <input type="date" id="established"><br><br>
        Töötajaid: <br>
        <input type="number" id="employees"><br><br>
        <button onclick="handleCompanyAdding()">Lisa</button>
    </div>
    <script>

        const API_URL = 'https://frogaccelerator.com:8110/companies';

        async function retrieveCompanies() {
            try {
                let response = await fetch(API_URL);
                let companies = await response.json();
                return companies;
            } catch (e) {
                console.log('Problems!!!', e);
                return null;
            }
        }

        async function postCompany(company) {
            try {
                await fetch(API_URL, {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json'
                    },
                    body: JSON.stringify(company)
                });
            } catch (e) {
                console.log('Problems!!!', e);
            }
        }

        async function renderCompanies() {
            let companies = await retrieveCompanies();

            let companiesHtml = '';
            for (const company of companies) {
                companiesHtml += /*html*/`
                    <h2>${company.name}</h2>
                    <div>Nimi: ${company.name}</div>
                    <div>Asutatud: ${company.established}</div>
                    <div>Töötajaid: ${company.employees}</div>
                    <hr>
                `;
            }

            document.querySelector('#companies').innerHTML = companiesHtml;
        }

        renderCompanies();

        async function handleCompanyAdding() {
            const name = document.querySelector('#name');
            const established = document.querySelector('#established');
            const employees = document.querySelector('#employees');

            const company = {
                name: name.value,
                established: established.value,
                employees: employees.value
            };

            await postCompany(company);
            renderCompanies();
        }

    </script>
</body>

</html>